
import os
import subprocess
import sys
import yaml

root_path = os.path.dirname(os.path.realpath(__file__)) + "/../.."
script_path = root_path + "/script"

sys.path.insert(1, script_path)
from rbc_utils import replace_in_file


### RQC preprocessing function
def preprocessing_src_rqc(sec_level, param_m):
    sec_level = str(sec_level)
    param_m = str(param_m)

    src_path = root_path + "/src/schemes/rqc"
    build_path = root_path + "/build/src/schemes/rqc" + sec_level

    subprocess.run("mkdir -p " + build_path, shell=True)
    subprocess.run("cp -r " + src_path + "/*" + " " + build_path, shell=True)
    subprocess.run("cp -r " + root_path + "/src/params/rqc" + sec_level + "/* " + root_path + "/build/src/schemes/rqc" + sec_level, shell=True)

    subprocess.run("mv " + build_path + "/rqc_parsing.h" + " " + build_path + "/rqc_" + sec_level + "_parsing.h", shell=True)
    subprocess.run("mv " + build_path + "/rqc_parsing.c" + " " + build_path + "/rqc_" + sec_level + "_parsing.c", shell=True)
    subprocess.run("mv " + build_path + "/rqc_pke.h"     + " " + build_path + "/rqc_" + sec_level + "_pke.h", shell=True)
    subprocess.run("mv " + build_path + "/rqc_pke.c"     + " " + build_path + "/rqc_" + sec_level + "_pke.c", shell=True)
    subprocess.run("mv " + build_path + "/rqc_kem.h"     + " " + build_path + "/rqc_" + sec_level + "_kem.h", shell=True)
    subprocess.run("mv " + build_path + "/rqc_kem.c"     + " " + build_path + "/rqc_" + sec_level + "_kem.c", shell=True)

    replace_in_file(build_path + "/CMakeLists.txt",                    "rqc", "rqc_" + sec_level);
    replace_in_file(build_path + "/CMakeLists.txt",                    "CORE_", "CORE_" + param_m + "_");
    replace_in_file(build_path + "/CMakeLists.txt",                    "GABIDULIN_", "GABIDULIN_" + param_m + "_");

    replace_in_file(build_path + "/rqc_" + sec_level + "_parsing.h",   "rqc_", "rqc_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_parsing.h",   "RQC_", "RQC_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_parsing.h",   "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rqc_" + sec_level + "_parsing.c",   "rqc_", "rqc_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_parsing.c",   "RQC_", "RQC_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_parsing.c",   "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rqc_" + sec_level + "_pke.h",       "rqc_", "rqc_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_pke.h",       "RQC_", "RQC_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_pke.h",       "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rqc_" + sec_level + "_pke.c",       "rqc_", "rqc_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_pke.c",       "RQC_", "RQC_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_pke.c",       "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rqc_" + sec_level + "_kem.h",       "rqc_", "rqc_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_kem.h",       "RQC_", "RQC_" + sec_level + "_");

    replace_in_file(build_path + "/rqc_" + sec_level + "_kem.c",       "rqc_", "rqc_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_kem.c",       "RQC_", "RQC_" + sec_level + "_");
    replace_in_file(build_path + "/rqc_" + sec_level + "_kem.c",       "rbc_", "rbc_" + param_m + "_");



### ROLLOI preprocessing function
def preprocessing_src_rolloI(sec_level, param_m):
    sec_level = str(sec_level)
    param_m = str(param_m)

    src_path = root_path + "/src/schemes/rolloI"
    build_path = root_path + "/build/src/schemes/rolloI" + sec_level

    subprocess.run("mkdir -p " + build_path, shell=True)
    subprocess.run("cp -r " + src_path + "/*" + " " + build_path, shell=True)
    subprocess.run("cp -r " + root_path + "/src/params/rolloI" + sec_level + "/* " + root_path + "/build/src/schemes/rolloI" + sec_level, shell=True)

    subprocess.run("mv " + build_path + "/rolloI_parsing.h" + " " + build_path + "/rolloI_" + sec_level + "_parsing.h", shell=True)
    subprocess.run("mv " + build_path + "/rolloI_parsing.c" + " " + build_path + "/rolloI_" + sec_level + "_parsing.c", shell=True)
    subprocess.run("mv " + build_path + "/rolloI_types.h"     + " " + build_path + "/rolloI_" + sec_level + "_types.h", shell=True)
    subprocess.run("mv " + build_path + "/rolloI_kem.h"     + " " + build_path + "/rolloI_" + sec_level + "_kem.h", shell=True)
    subprocess.run("mv " + build_path + "/rolloI_kem.c"     + " " + build_path + "/rolloI_" + sec_level + "_kem.c", shell=True)

    replace_in_file(build_path + "/CMakeLists.txt",                    "rolloI", "rolloI_" + sec_level);
    replace_in_file(build_path + "/CMakeLists.txt",                    "CORE_", "CORE_" + param_m + "_");
    replace_in_file(build_path + "/CMakeLists.txt",                    "LRPC_", "LRPC_" + param_m + "_");

    replace_in_file(build_path + "/rolloI_" + sec_level + "_parsing.h",   "rolloI_", "rolloI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_parsing.h",   "ROLLOI_", "ROLLOI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_parsing.h",   "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloI_" + sec_level + "_parsing.c",   "rolloI_", "rolloI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_parsing.c",   "ROLLOI_", "ROLLOI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_parsing.c",   "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloI_" + sec_level + "_types.h",       "rolloI_", "rolloI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_types.h",       "ROLLOI_", "ROLLOI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_types.h",       "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloI_" + sec_level + "_kem.c",       "rolloI_", "rolloI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_kem.c",       "ROLLOI_", "ROLLOI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_kem.c",       "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloI_" + sec_level + "_kem.h",       "rolloI_", "rolloI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_kem.h",       "ROLLOI_", "ROLLOI_" + sec_level + "_");
    replace_in_file(build_path + "/rolloI_" + sec_level + "_kem.h",       "rbc_", "rbc_" + param_m + "_");



### ROLLOII preprocessing function
def preprocessing_src_rolloII(sec_level, param_m):
    sec_level = str(sec_level)
    param_m = str(param_m)

    src_path = root_path + "/src/schemes/rolloII"
    build_path = root_path + "/build/src/schemes/rolloII" + sec_level

    subprocess.run("mkdir -p " + build_path, shell=True)
    subprocess.run("cp -r " + src_path + "/*" + " " + build_path, shell=True)
    subprocess.run("cp -r " + root_path + "/src/params/rolloII" + sec_level + "/* " + root_path + "/build/src/schemes/rolloII" + sec_level, shell=True)

    subprocess.run("mv " + build_path + "/rolloII_parsing.h" + " " + build_path + "/rolloII_" + sec_level + "_parsing.h", shell=True)
    subprocess.run("mv " + build_path + "/rolloII_parsing.c" + " " + build_path + "/rolloII_" + sec_level + "_parsing.c", shell=True)
    subprocess.run("mv " + build_path + "/rolloII_types.h"     + " " + build_path + "/rolloII_" + sec_level + "_types.h", shell=True)
    subprocess.run("mv " + build_path + "/rolloII_kem.h"     + " " + build_path + "/rolloII_" + sec_level + "_kem.h", shell=True)
    subprocess.run("mv " + build_path + "/rolloII_kem.c"     + " " + build_path + "/rolloII_" + sec_level + "_kem.c", shell=True)

    replace_in_file(build_path + "/CMakeLists.txt",                    "rolloII", "rolloII_" + sec_level);
    replace_in_file(build_path + "/CMakeLists.txt",                    "CORE_", "CORE_" + param_m + "_");
    replace_in_file(build_path + "/CMakeLists.txt",                    "LRPC_", "LRPC_" + param_m + "_");

    replace_in_file(build_path + "/rolloII_" + sec_level + "_parsing.h",   "rolloII_", "rolloII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_parsing.h",   "ROLLOII_", "ROLLOII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_parsing.h",   "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloII_" + sec_level + "_parsing.c",   "rolloII_", "rolloII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_parsing.c",   "ROLLOII_", "ROLLOII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_parsing.c",   "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloII_" + sec_level + "_types.h",       "rolloII_", "rolloII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_types.h",       "ROLLOII_", "ROLLOII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_types.h",       "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloII_" + sec_level + "_kem.c",       "rolloII_", "rolloII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_kem.c",       "ROLLOII_", "ROLLOII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_kem.c",       "rbc_", "rbc_" + param_m + "_");

    replace_in_file(build_path + "/rolloII_" + sec_level + "_kem.h",       "rolloII_", "rolloII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_kem.h",       "ROLLOII_", "ROLLOII_" + sec_level + "_");
    replace_in_file(build_path + "/rolloII_" + sec_level + "_kem.h",       "rbc_", "rbc_" + param_m + "_");

