
#include <stdio.h>
#include <sys/syscall.h>
#include "rbc.h"

int main() {

  unsigned char rolloI_128_pk[ROLLOI_128_PUBLIC_KEY_BYTES];
  unsigned char rolloI_128_sk[ROLLOI_128_SECRET_KEY_BYTES];

  unsigned char rolloI_128_ct[ROLLOI_128_CIPHERTEXT_BYTES];
  unsigned char rolloI_128_ss1[ROLLOI_128_SHARED_SECRET_BYTES];
  unsigned char rolloI_128_ss2[ROLLOI_128_SHARED_SECRET_BYTES];
  
  rolloI_128_kem_keygen(rolloI_128_pk, rolloI_128_sk);
  rolloI_128_kem_encaps(rolloI_128_ct, rolloI_128_ss1, rolloI_128_pk);
  rolloI_128_kem_decaps(rolloI_128_ss2, rolloI_128_ct, rolloI_128_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < ROLLOI_128_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloI_128_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < ROLLOI_128_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloI_128_ss2[i]);
  printf("\n\n");



  unsigned char rolloI_192_pk[ROLLOI_192_PUBLIC_KEY_BYTES];
  unsigned char rolloI_192_sk[ROLLOI_192_SECRET_KEY_BYTES];

  unsigned char rolloI_192_ct[ROLLOI_192_CIPHERTEXT_BYTES];
  unsigned char rolloI_192_ss1[ROLLOI_192_SHARED_SECRET_BYTES];
  unsigned char rolloI_192_ss2[ROLLOI_192_SHARED_SECRET_BYTES];
  
  rolloI_192_kem_keygen(rolloI_192_pk, rolloI_192_sk);
  rolloI_192_kem_encaps(rolloI_192_ct, rolloI_192_ss1, rolloI_192_pk);
  rolloI_192_kem_decaps(rolloI_192_ss2, rolloI_192_ct, rolloI_192_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < ROLLOI_192_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloI_192_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < ROLLOI_192_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloI_192_ss2[i]);
  printf("\n\n");



  unsigned char rolloI_256_pk[ROLLOI_256_PUBLIC_KEY_BYTES];
  unsigned char rolloI_256_sk[ROLLOI_256_SECRET_KEY_BYTES];

  unsigned char rolloI_256_ct[ROLLOI_256_CIPHERTEXT_BYTES];
  unsigned char rolloI_256_ss1[ROLLOI_256_SHARED_SECRET_BYTES];
  unsigned char rolloI_256_ss2[ROLLOI_256_SHARED_SECRET_BYTES];
  
  rolloI_256_kem_keygen(rolloI_256_pk, rolloI_256_sk);
  rolloI_256_kem_encaps(rolloI_256_ct, rolloI_256_ss1, rolloI_256_pk);
  rolloI_256_kem_decaps(rolloI_256_ss2, rolloI_256_ct, rolloI_256_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < ROLLOI_256_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloI_256_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < ROLLOI_256_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloI_256_ss2[i]);
  printf("\n\n");

}

