
#include <stdio.h>
#include <sys/syscall.h>
#include "rbc.h"

int main() {

  unsigned char rolloII_128_pk[ROLLOII_128_PUBLIC_KEY_BYTES];
  unsigned char rolloII_128_sk[ROLLOII_128_SECRET_KEY_BYTES];

  unsigned char rolloII_128_ct[ROLLOII_128_CIPHERTEXT_BYTES];
  unsigned char rolloII_128_ss1[ROLLOII_128_SHARED_SECRET_BYTES];
  unsigned char rolloII_128_ss2[ROLLOII_128_SHARED_SECRET_BYTES];
  
  rolloII_128_kem_keygen(rolloII_128_pk, rolloII_128_sk);
  rolloII_128_kem_encaps(rolloII_128_ct, rolloII_128_ss1, rolloII_128_pk);
  rolloII_128_kem_decaps(rolloII_128_ss2, rolloII_128_ct, rolloII_128_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < ROLLOII_128_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloII_128_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < ROLLOII_128_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloII_128_ss2[i]);
  printf("\n\n");



  unsigned char rolloII_192_pk[ROLLOII_192_PUBLIC_KEY_BYTES];
  unsigned char rolloII_192_sk[ROLLOII_192_SECRET_KEY_BYTES];

  unsigned char rolloII_192_ct[ROLLOII_192_CIPHERTEXT_BYTES];
  unsigned char rolloII_192_ss1[ROLLOII_192_SHARED_SECRET_BYTES];
  unsigned char rolloII_192_ss2[ROLLOII_192_SHARED_SECRET_BYTES];
  
  rolloII_192_kem_keygen(rolloII_192_pk, rolloII_192_sk);
  rolloII_192_kem_encaps(rolloII_192_ct, rolloII_192_ss1, rolloII_192_pk);
  rolloII_192_kem_decaps(rolloII_192_ss2, rolloII_192_ct, rolloII_192_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < ROLLOII_192_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloII_192_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < ROLLOII_192_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloII_192_ss2[i]);
  printf("\n\n");



  unsigned char rolloII_256_pk[ROLLOII_256_PUBLIC_KEY_BYTES];
  unsigned char rolloII_256_sk[ROLLOII_256_SECRET_KEY_BYTES];

  unsigned char rolloII_256_ct[ROLLOII_256_CIPHERTEXT_BYTES];
  unsigned char rolloII_256_ss1[ROLLOII_256_SHARED_SECRET_BYTES];
  unsigned char rolloII_256_ss2[ROLLOII_256_SHARED_SECRET_BYTES];
  
  rolloII_256_kem_keygen(rolloII_256_pk, rolloII_256_sk);
  rolloII_256_kem_encaps(rolloII_256_ct, rolloII_256_ss1, rolloII_256_pk);
  rolloII_256_kem_decaps(rolloII_256_ss2, rolloII_256_ct, rolloII_256_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < ROLLOII_256_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloII_256_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < ROLLOII_256_SHARED_SECRET_BYTES ; ++i) printf("%02x", rolloII_256_ss2[i]);
  printf("\n\n");

}

