
#include <stdio.h>
#include <sys/syscall.h>
#include "rbc.h"

int main() {

  unsigned char rqc_128_pk[RQC_128_PUBLIC_KEY_BYTES];
  unsigned char rqc_128_sk[RQC_128_SECRET_KEY_BYTES];

  unsigned char rqc_128_ct[RQC_128_CIPHERTEXT_BYTES];
  unsigned char rqc_128_ss1[RQC_128_SHARED_SECRET_BYTES];
  unsigned char rqc_128_ss2[RQC_128_SHARED_SECRET_BYTES];
  
  rqc_128_kem_keygen(rqc_128_pk, rqc_128_sk);
  rqc_128_kem_encaps(rqc_128_ct, rqc_128_ss1, rqc_128_pk);
  rqc_128_kem_decaps(rqc_128_ss2, rqc_128_ct, rqc_128_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < RQC_128_SHARED_SECRET_BYTES ; ++i) printf("%02x", rqc_128_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < RQC_128_SHARED_SECRET_BYTES ; ++i) printf("%02x", rqc_128_ss2[i]);
  printf("\n\n");



  unsigned char rqc_192_pk[RQC_192_PUBLIC_KEY_BYTES];
  unsigned char rqc_192_sk[RQC_192_SECRET_KEY_BYTES];

  unsigned char rqc_192_ct[RQC_192_CIPHERTEXT_BYTES];
  unsigned char rqc_192_ss1[RQC_192_SHARED_SECRET_BYTES];
  unsigned char rqc_192_ss2[RQC_192_SHARED_SECRET_BYTES];
  
  rqc_192_kem_keygen(rqc_192_pk, rqc_192_sk);
  rqc_192_kem_encaps(rqc_192_ct, rqc_192_ss1, rqc_192_pk);
  rqc_192_kem_decaps(rqc_192_ss2, rqc_192_ct, rqc_192_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < RQC_192_SHARED_SECRET_BYTES ; ++i) printf("%02x", rqc_192_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < RQC_192_SHARED_SECRET_BYTES ; ++i) printf("%02x", rqc_192_ss2[i]);
  printf("\n\n");



  unsigned char rqc_256_pk[RQC_256_PUBLIC_KEY_BYTES];
  unsigned char rqc_256_sk[RQC_256_SECRET_KEY_BYTES];

  unsigned char rqc_256_ct[RQC_256_CIPHERTEXT_BYTES];
  unsigned char rqc_256_ss1[RQC_256_SHARED_SECRET_BYTES];
  unsigned char rqc_256_ss2[RQC_256_SHARED_SECRET_BYTES];
  
  rqc_256_kem_keygen(rqc_256_pk, rqc_256_sk);
  rqc_256_kem_encaps(rqc_256_ct, rqc_256_ss1, rqc_256_pk);
  rqc_256_kem_decaps(rqc_256_ss2, rqc_256_ct, rqc_256_sk);

  printf("\n\nsecret1: ");
  for(int i = 0 ; i < RQC_256_SHARED_SECRET_BYTES ; ++i) printf("%02x", rqc_256_ss1[i]);

  printf("\nsecret2: ");
  for(int i = 0 ; i < RQC_256_SHARED_SECRET_BYTES ; ++i) printf("%02x", rqc_256_ss2[i]);
  printf("\n\n");

}

